<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: CollisionBonus Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classCollisionBonus-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CollisionBonus Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Resolves collision between <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> and other objects.  
 <a href="classCollisionBonus.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="CollisionVisitor_8h_source.html">CollisionVisitor.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for CollisionBonus:</div>
<div class="dyncontent">
<div class="center"><img src="classCollisionBonus__inherit__graph.png" border="0" usemap="#CollisionBonus_inherit__map" alt="Inheritance graph"/></div>
<map name="CollisionBonus_inherit__map" id="CollisionBonus_inherit__map">
<area shape="rect" title="Resolves collision between Bonus and other objects." alt="" coords="6,80,125,107"/>
<area shape="rect" href="classCollisionVisitor.html" title="Abstract class of double dispatch visitor design patter." alt="" coords="5,5,125,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for CollisionBonus:</div>
<div class="dyncontent">
<div class="center"><img src="classCollisionBonus__coll__graph.png" border="0" usemap="#CollisionBonus_coll__map" alt="Collaboration graph"/></div>
<map name="CollisionBonus_coll__map" id="CollisionBonus_coll__map">
<area shape="rect" title="Resolves collision between Bonus and other objects." alt="" coords="27,247,146,273"/>
<area shape="rect" href="classCollisionVisitor.html" title="Abstract class of double dispatch visitor design patter." alt="" coords="5,157,125,184"/>
<area shape="rect" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player." alt="" coords="150,157,213,184"/>
<area shape="rect" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties." alt="" coords="130,81,233,108"/>
<area shape="rect" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce..." alt="" coords="149,5,213,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad49b207ae84e9f714dc64e1e11a8b8e6"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionBonus.html#ad49b207ae84e9f714dc64e1e11a8b8e6">CollisionBonus</a> (<a class="el" href="classBonus.html">Bonus</a> *bonus)</td></tr>
<tr class="memdesc:ad49b207ae84e9f714dc64e1e11a8b8e6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new Collision <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> object with <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> pointer.  <a href="classCollisionBonus.html#ad49b207ae84e9f714dc64e1e11a8b8e6">More...</a><br /></td></tr>
<tr class="separator:ad49b207ae84e9f714dc64e1e11a8b8e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff73cb5263fadec07b617171936ce3f2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionBonus.html#aff73cb5263fadec07b617171936ce3f2">VisitEnemy</a> (<a class="el" href="classEnemy.html">Enemy</a> *enemy) override</td></tr>
<tr class="memdesc:aff73cb5263fadec07b617171936ce3f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets <a class="el" href="classEnemy.html" title="Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death.">Enemy</a> pointer from visiting object.  <a href="classCollisionBonus.html#aff73cb5263fadec07b617171936ce3f2">More...</a><br /></td></tr>
<tr class="separator:aff73cb5263fadec07b617171936ce3f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aea3256a97e9b80d02a0c1234d47694e1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionBonus.html#aea3256a97e9b80d02a0c1234d47694e1">VisitProjectile</a> (<a class="el" href="classProjectile.html">Projectile</a> *projectile) override</td></tr>
<tr class="memdesc:aea3256a97e9b80d02a0c1234d47694e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets <a class="el" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites">Projectile</a> pointer from visiting object.  <a href="classCollisionBonus.html#aea3256a97e9b80d02a0c1234d47694e1">More...</a><br /></td></tr>
<tr class="separator:aea3256a97e9b80d02a0c1234d47694e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a465bb52368516d6ebf0db27aa1096f1b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionBonus.html#a465bb52368516d6ebf0db27aa1096f1b">VisitPlayer</a> (<a class="el" href="classPlayer.html">Player</a> *player) override</td></tr>
<tr class="memdesc:a465bb52368516d6ebf0db27aa1096f1b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets <a class="el" href="classPlayer.html" title="Represent player, takes user input.">Player</a> pointer from visiting object.  <a href="classCollisionBonus.html#a465bb52368516d6ebf0db27aa1096f1b">More...</a><br /></td></tr>
<tr class="separator:a465bb52368516d6ebf0db27aa1096f1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3deb7dbb790606457edd73a4443d1001"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionBonus.html#a3deb7dbb790606457edd73a4443d1001">VisitBonus</a> (<a class="el" href="classBonus.html">Bonus</a> *bonus) override</td></tr>
<tr class="memdesc:a3deb7dbb790606457edd73a4443d1001"><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> pointer from visiting object.  <a href="classCollisionBonus.html#a3deb7dbb790606457edd73a4443d1001">More...</a><br /></td></tr>
<tr class="separator:a3deb7dbb790606457edd73a4443d1001"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a6635fa7d9cad4ed70228b74c7129dcd6"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classBonus.html">Bonus</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCollisionBonus.html#a6635fa7d9cad4ed70228b74c7129dcd6">m_Bonus</a> = nullptr</td></tr>
<tr class="separator:a6635fa7d9cad4ed70228b74c7129dcd6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Resolves collision between <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> and other objects. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ad49b207ae84e9f714dc64e1e11a8b8e6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad49b207ae84e9f714dc64e1e11a8b8e6">&#9670;&nbsp;</a></span>CollisionBonus()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">CollisionBonus::CollisionBonus </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classBonus.html">Bonus</a> *&#160;</td>
          <td class="paramname"><em>bonus</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Construct a new Collision <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> object with <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> pointer. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a3deb7dbb790606457edd73a4443d1001"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3deb7dbb790606457edd73a4443d1001">&#9670;&nbsp;</a></span>VisitBonus()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CollisionBonus::VisitBonus </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classBonus.html">Bonus</a> *&#160;</td>
          <td class="paramname"><em>bonus</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> pointer from visiting object. </p>

<p>Implements <a class="el" href="classCollisionVisitor.html#ac21e99081aed7153372f3aa3b72e7cf5">CollisionVisitor</a>.</p>

</div>
</div>
<a id="aff73cb5263fadec07b617171936ce3f2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff73cb5263fadec07b617171936ce3f2">&#9670;&nbsp;</a></span>VisitEnemy()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CollisionBonus::VisitEnemy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classEnemy.html">Enemy</a> *&#160;</td>
          <td class="paramname"><em>enemy</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets <a class="el" href="classEnemy.html" title="Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death.">Enemy</a> pointer from visiting object. </p>

<p>Implements <a class="el" href="classCollisionVisitor.html#af05d93df91ad1b3b7fbf939cbb8f2c28">CollisionVisitor</a>.</p>

</div>
</div>
<a id="a465bb52368516d6ebf0db27aa1096f1b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a465bb52368516d6ebf0db27aa1096f1b">&#9670;&nbsp;</a></span>VisitPlayer()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CollisionBonus::VisitPlayer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classPlayer.html">Player</a> *&#160;</td>
          <td class="paramname"><em>player</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets <a class="el" href="classPlayer.html" title="Represent player, takes user input.">Player</a> pointer from visiting object. </p>

<p>Implements <a class="el" href="classCollisionVisitor.html#a27165ce473133803b0cf2e7343686876">CollisionVisitor</a>.</p>

</div>
</div>
<a id="aea3256a97e9b80d02a0c1234d47694e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aea3256a97e9b80d02a0c1234d47694e1">&#9670;&nbsp;</a></span>VisitProjectile()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CollisionBonus::VisitProjectile </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classProjectile.html">Projectile</a> *&#160;</td>
          <td class="paramname"><em>projectile</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Gets <a class="el" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites">Projectile</a> pointer from visiting object. </p>

<p>Implements <a class="el" href="classCollisionVisitor.html#a0fb0fccfcfe6bf348588a406b3e26407">CollisionVisitor</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a6635fa7d9cad4ed70228b74c7129dcd6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6635fa7d9cad4ed70228b74c7129dcd6">&#9670;&nbsp;</a></span>m_Bonus</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classBonus.html">Bonus</a>* CollisionBonus::m_Bonus = nullptr</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="CollisionVisitor_8h_source.html">CollisionVisitor.h</a></li>
<li>src/<a class="el" href="CollisionVisitor_8cpp.html">CollisionVisitor.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
